package com.minecraftserverzone.weaponmaster.gui;

import java.io.IOException;

import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.math.NumberUtils;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.gui.normalbutton.Button;
import com.minecraftserverzone.weaponmaster.gui.slider.NewForgeSlider;
import com.minecraftserverzone.weaponmaster.gui.smallButton.SmallButton;
import com.minecraftserverzone.weaponmaster.gui.togglebutton.ToggleButton;
import com.minecraftserverzone.weaponmaster.setup.KeyHandler;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;
import com.minecraftserverzone.weaponmaster.setup.helper.FastColor;
import com.minecraftserverzone.weaponmaster.setup.helper.GuiHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.KeyHelper;
import com.minecraftserverzone.weaponmaster.setup.helper.ModUtils;
import com.minecraftserverzone.weaponmaster.setup.networking.Networking;
import com.minecraftserverzone.weaponmaster.setup.networking.server.UniqueItemSettingsSPacket;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextComponentTranslation;

public class UniqueItemSettingScreen extends GuiScreen {
	public String text = "empty";
	public static String textFromConfig = "empty";
	public boolean textFocused = false;
	public boolean selectText = false;
	private boolean draggingPlayerMode;
	public int hoverValue = 0;
	public boolean shiftDown = false;
	private Button resetButton;
	private Button removeButton;
	private Button normalbuttons;
	public static String selectedText = "";
	
	public static NewForgeSlider posx;
	public static NewForgeSlider posy;
	public static NewForgeSlider posz;
	
	public static NewForgeSlider rotx;
	public static NewForgeSlider roty;
	public static NewForgeSlider rotz;
	
	public static NewForgeSlider scaleButton;
	public static SmallButton scalePlus;
	public static SmallButton scaleMinus;
	
	public static SmallButton posxplus;
	public static SmallButton posyplus;
	public static SmallButton poszplus;
	public static SmallButton rotxplus;
	public static SmallButton rotyplus;
	public static SmallButton rotzplus;
	
	public static SmallButton posxminus;
	public static SmallButton posyminus;
	public static SmallButton poszminus;
	public static SmallButton rotxminus;
	public static SmallButton rotyminus;
	public static SmallButton rotzminus;

	public static ToggleButton[] slotButton = new ToggleButton[WeaponMasterMod.maxDisplaySlotNum];
	
//	private ToggleButton helmet;
//	private ToggleButton chestplate;
//	private ToggleButton legs;
//	private ToggleButton boots;
//	private ToggleButton slotMoverX;
//	private ToggleButton slotMoverY;
//	private ToggleButton slotMoverZ;
//	private ToggleButton slotMoverPlus;
//	private ToggleButton slotMoverMinus;
//	
//	public ToggleButton[] attachmentButton = new ToggleButton[6];
//	public ToggleButton[] slotMoverSlots = new ToggleButton[WeaponMasterMod.maxDisplaySlotNum];
//	private String[] bodyattachment = {"","","","","",""};
//	private String[] moveSlots = {"","","","","",""};
//	private String[] moveTypes = {"","","","","",""};
	
	public UniqueItemSettingScreen() {
	}
	
	public void reset() {
		if(ModUtils.stringContains(selectedText, ",")) {
			setValues(posx, 0);
			setValues(posy, 0);
			setValues(posz, 0);
			setValues(rotx, 0);
			setValues(roty, 0);
			setValues(rotz, 0);
			setValues(scaleButton, 0);
			
			setData();
		}
	}

	public void remove() {
		if(ModUtils.stringContains(ClientOnlyForgeSetup.uniqueItemDisplay, selectedText)) {
			if(ModUtils.stringContains(selectedText, ",")) {
				String name = StringUtils.substringBefore(selectedText, ",");
				String slot = "-1";
				String[] selectedArray = selectedText.split(",");
				
				if(ModUtils.arrayExist(selectedArray, 9)) {
					if(ModUtils.stringExist(selectedArray[8])) {
						slot = selectedArray[8];
					}
				}
				
				if(ModUtils.stringContains(ClientOnlyForgeSetup.uniqueItemDisplay, " ")) {
					String[] txtArray = ClientOnlyForgeSetup.uniqueItemDisplay.split(" ");
					String temptxt = "";

					boolean found = false;
					
					for(int i = 0; i < txtArray.length; i++) {
						if(ModUtils.stringContains(txtArray[i], ",")) {
							String[] data = txtArray[i].split(",");

							if(ModUtils.arrayExist(data, 9)) {
								if(!found && ModUtils.stringContains(data[0], name) && data[8].equals(slot)) { //name and slot name
									found = true;
								}else {
									if(ModUtils.stringExist(temptxt)) {
										temptxt+=" ";
									}
									temptxt += txtArray[i];
								}
							}
						}
					}
					
					try {
					selectedText = "";
					ClientOnlyForgeSetup.uniqueItemDisplay = temptxt;
					}catch (Exception e) {}
				}else {
					try {
					selectedText = "";
					ClientOnlyForgeSetup.uniqueItemDisplay = "empty,0,0,0,0,0,0,0,1";
					}catch (Exception e) {}
				}
				textFromConfig = ClientOnlyForgeSetup.uniqueItemDisplay;
			}
		}
	}
	
	@Override
	public void func_73866_w_() {
		if(ModUtils.stringExist(ClientOnlyForgeSetup.uniqueItemDisplay)) {
			textFromConfig = ClientOnlyForgeSetup.uniqueItemDisplay;
		}
		
		this.field_146292_n.add(normalbuttons = (new Button(field_146294_l/2 - 5 - field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID+".screen.addtext").func_150254_d())/2, 75, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID+".screen.addtext").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.addtext"), (p_96337_) -> {
			addText();
		})));
		
		this.field_146292_n.add(removeButton = (new Button(field_146294_l/2 + 5, field_146295_m - 40, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID+".screen.remove").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.remove"), (p_96337_) -> {
			remove();
		})));
		
		this.field_146292_n.add(resetButton = (new Button(field_146294_l/2 - 15 - field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID+".screen.reset").func_150254_d()), field_146295_m - 40, 10 + field_146289_q.func_78256_a(new TextComponentTranslation(WeaponMasterMod.MODID+".screen.reset").func_150254_d()), 20, new TextComponentTranslation(WeaponMasterMod.MODID + ".screen.reset"), (p_96337_) -> {
			reset();
		})));
		
		int translateY = 30;
		
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			final int slot = i;
			ITextComponent text = new TextComponentString(String.valueOf(slot+1));
			int xsize = 16;
			int xpos = 1 + (slot * 16);
			int ypos = 0;
			
			if(i == 9) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
				xpos = 1 + (slot * 16);
			}else if(i == 10) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner").func_150254_d());
				xpos = 4 + (slot * 16) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
			}else if(i == 11) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.offhand");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.offhand").func_150254_d());
				xpos = 8 + (slot * 16) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner").func_150254_d()) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
			}else if(i == 12) {
				text = new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.quiver");
				xsize = 20 + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.quiver").func_150254_d());
				xpos = 8 + ((slot-1) * 16) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.banner").func_150254_d()) + this.field_146289_q.func_78256_a(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.shield").func_150254_d());
			
			}

			this.field_146292_n.add(slotButton[i] = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
				selectSlot(slot);
			}, slot == 0 ? true : false, 0)));
		}
//		{
//		//attachment buttons
//		int xsize = 10 + font.getStringWidth(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.head"));
//		int xpos = 5;
//		int ypos = translateY + 260;
//		attachmentButton[0] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.head"), (p_96337_) -> {
//			setAttachment(0, "head");
//		}, bodyattachment[1].equals("head"), 1));
//		
//		xpos = 5;
//		ypos = translateY + 280;
//		xsize = 10 + font.getStringWidth(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.body"));
//		attachmentButton[1] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.body"), (p_96337_) -> {
//			setAttachment(1, "body");
//		}, bodyattachment[1].equals("body"), 1 ));
//		
//		xpos = 5;
//		ypos = translateY + 300;
//		xsize = 10 + font.getStringWidth(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.larm"));
//		attachmentButton[3] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.larm"), (p_96337_) -> {
//			setAttachment(3, "larm");
//		}, bodyattachment[1].equals("larm"), 1));
//		
//		xpos += xsize;
//		xsize = 10 + font.getStringWidth(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rarm"));
//		attachmentButton[2] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rarm"), (p_96337_) -> {
//			setAttachment(2, "rarm");
//		}, bodyattachment[1].equals("rarm"), 1));
//		
//		xpos = 5;
//		ypos = translateY + 320;
//		xsize = 10 + font.getStringWidth(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.lleg"));
//		attachmentButton[5] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.lleg"), (p_96337_) -> {
//			setAttachment(5, "lleg");
//		}, bodyattachment[1].equals("lleg"), 1));
//		
//		xpos += xsize;
//		xsize = 10 + font.getStringWidth(new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rleg"));
//		attachmentButton[4] = (new ToggleButton(xpos, ypos, xsize, 20, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".attach.rleg"), (p_96337_) -> {
//			setAttachment(4, "rleg");
//		}, bodyattachment [1].equals("rleg"), 1));
//		}
//		
//		{
//		//slot mover for equipments
//		ITextComponent text = new TextComponentString("");//helmet
//		int xsize = 14;
//		int xpos = 3;
//		int ypos = translateY + 215;
//		int slot = 1;
//		
//		helmet = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 0, "helm");
//		}, moveSlots[0].contains("helm"), 0));
//		
//		xpos = 3 + xsize; //chest
//		chestplate = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 0, "chest");
//		}, moveSlots[0].contains("chest"), 0));
//		
//		xpos = 3 + xsize * 2; //legs
//		legs = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 0, "legs");
//		}, moveSlots[0].contains("legs"), 0));
//		
//		xpos = 3 + xsize *3; //boots
//		boots = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 0, "boots");
//		}, moveSlots[0].contains("boots"), 0));
//		
//		//xyz +- buttons
//		xsize = 12;
//		text = new TextComponentString("x");
//		xpos = 80;
//		ypos = translateY + 215;
//		slotMoverX = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 1, "x");
//		}, moveTypes[1].equals("x"), 0));
//		
//		text = new TextComponentString("y");
//		xpos = 80 + xsize;
//		slotMoverY = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 1, "y");
//		}, moveTypes[1].equals("y"), 0));
//		
//		text = new TextComponentString("z");
//		xpos = 80 + (xsize*2);
//		slotMoverZ = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 1, "z");
//		}, moveTypes[1].equals("z"), 0));
//		
//		text = new TextComponentString("+");
//		xpos = 80 + (xsize*3);
//		slotMoverPlus = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 2, "+");
//		}, moveTypes[2].equals("+"), 0));
//		
//		text = new TextComponentString("-");
//		xpos = 80 + (xsize*4);
//		slotMoverMinus = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (p_96337_) -> {
//			changeSlotMover(slot, 2, "-");
//		}, moveTypes[2].equals("-"), 0));
//		}
//		
//		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
//			ITextComponent text = new TextComponentString(String.valueOf(i+1));
//			int xsize = 12;
//			int xpos = 5 + (i * xsize);
//			int ypos = translateY;
//			xpos = 5 + (i * xsize);
//			ypos = translateY + 190;
//			String string = text.getFormattedText();
//			
//			if(i == 9) {
//				text = new TextComponentString("");
//				string = "shield";
//			}else if(i == 10) {
//				text = new TextComponentString("");
//				string = "banner";
//			}else if(i == 11) {
//				text = new TextComponentString("");
//				string = "offhand";
//			}else if(i == 12) {
//				text = new TextComponentString("");
//				string = "quiver";
//			}
//			final String str = string;
//			final int j = i;
//			
//			slotMoverSlots[i] = (new ToggleButton(xpos - 1, ypos, xsize, 20, text, (s) -> {
//				//openOtherScreen(slot);
//				changeSlotMover(j, 0, str);
//		}, moveSlots[0].contains(str), 0)); //false -> moveSlots[selectedScreen].contains(str)
//		}
		
		{
		//plus minus and slider buttons
		int xsize = 12;
		ITextComponent text = new TextComponentString(">");
		int xpos = 130;
		int ypos = translateY + 120;
		this.field_146292_n.add(posxplus = (new SmallButton(xpos, ypos - 72, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "x", true); //position or rotation, direction - xyz, plus or minus
		})));
		this.field_146292_n.add(posyplus = (new SmallButton(xpos, ypos - 58, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "y", true);
		})));
		this.field_146292_n.add(poszplus = (new SmallButton(xpos, ypos - 44, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "z", true);
		})));
		
		this.field_146292_n.add(rotxplus = (new SmallButton(xpos, ypos - 27, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "x", true);
		})));
		this.field_146292_n.add(rotyplus = (new SmallButton(xpos, ypos - 13, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "y", true);
		})));
		this.field_146292_n.add(rotzplus = (new SmallButton(xpos, ypos + 1, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "z", true);
		})));
		
		//minus
		xsize = 12;
		text = new TextComponentString("<");
		xpos = 1;
		ypos = translateY + 120;
		this.field_146292_n.add(posxminus = (new SmallButton(xpos, ypos - 72, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "x", false); //position or rotation, direction - xyz, plus or minus
		})));
		this.field_146292_n.add(posyminus = (new SmallButton(xpos, ypos - 58, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "y", false);
		})));
		this.field_146292_n.add(poszminus = (new SmallButton(xpos, ypos - 44, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(true, "z", false);
		})));
		
		this.field_146292_n.add(rotxminus = (new SmallButton(xpos, ypos - 27, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "x", false);
		})));
		this.field_146292_n.add(rotyminus = (new SmallButton(xpos, ypos - 13, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "y", false);
		})));
		this.field_146292_n.add(rotzminus = (new SmallButton(xpos, ypos + 1, xsize, 13, text, (p_96337_) -> {
			changePosOrRot(false, "z", false);
		})));
		
		//scale buttons
		ypos = translateY + 120;
		xpos = 130;
		this.field_146292_n.add(scalePlus = (new SmallButton(xpos, ypos + 20, xsize, 13, new TextComponentString(">"), (p_96337_) -> {
			changePosOrRot(false, "scale", true);
		})));
		xpos = 1;
		this.field_146292_n.add(scaleMinus = (new SmallButton(xpos, ypos + 20, xsize, 13, new TextComponentString("<"), (p_96337_) -> {
			changePosOrRot(false, "scale", false);
		})));
		}
		
		{
		//pos and rot buttons
		int xpos = 22;
		int ypos = translateY + 131;
		this.field_146292_n.add(posx = (new NewForgeSlider(xpos, ypos - 83, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.posx"), new TextComponentString(""), -100, 100, 0, true)));
		this.field_146292_n.add(posy = (new NewForgeSlider(xpos, ypos - 69, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.posy"), new TextComponentString(""), -100, 100, 0, true)));
		this.field_146292_n.add(posz = (new NewForgeSlider(xpos, ypos - 55, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.posz"), new TextComponentString(""), -100, 100, 0, true)));
		
		this.field_146292_n.add(rotx= (new NewForgeSlider(xpos, ypos - 38, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.rotx"), new TextComponentString(""), -180, 180, 0, true)));
		this.field_146292_n.add(roty = (new NewForgeSlider(xpos, ypos - 24, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.roty"), new TextComponentString(""), -180, 180, 0, true)));
		this.field_146292_n.add(rotz = (new NewForgeSlider(xpos, ypos - 10, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.rotz"), new TextComponentString(""), -180, 180, 0, true)));
		
		this.field_146292_n.add(scaleButton = (new NewForgeSlider(xpos, ypos + 9, 100, 13, new TextComponentTranslation("gui."+WeaponMasterMod.MODID+".slot.scale"), new TextComponentString(""), -100, 100, 0, true)));
		}
		
		super.func_73866_w_();
	}
	
	public void selectSlot(int slot) {
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			if(i == slot) {
				slotButton[i].toggle = true;
			}else {
				slotButton[i].toggle = false;
			}
		}
		setData();
	}

	public void visible(boolean value) {
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			slotButton[i].visible = value;

			
			if(i == 11) {
				slotButton[i].visible = false;
			}
//			if(i < 6) {
//				attachmentButton[i].visible = value;
//			}
//			slotMoverSlots[i].visible = value;
		}
		posx.visible = value;
		posy.visible = value;
		posz.visible = value;
		rotx.visible = value;
		roty.visible = value;
		rotz.visible = value;
		scaleButton.visible = value;
		scalePlus.visible = value;
		scaleMinus.visible = value;
//		helmet.visible = value;
//		chestplate.visible = value;
//		legs.visible = value;
//		boots.visible = value;
//		slotMoverX.visible = value;
//		slotMoverY.visible = value;
//		slotMoverZ.visible = value;
//		slotMoverPlus.visible = value;
//		slotMoverMinus.visible = value;
		posxplus.visible = value;
		posyplus.visible = value;
		poszplus.visible = value;
		rotxplus.visible = value;
		rotyplus.visible = value;
		rotzplus.visible = value;
		posxminus.visible = value;
		posyminus.visible = value;
		poszminus.visible = value;
		rotxminus.visible = value;
		rotyminus.visible = value;
		rotzminus.visible = value;
		
		if(ModUtils.stringContains(selectedText, ",")) {
			removeButton.visible = value;
			resetButton.visible = value;
		}else {
			removeButton.visible = false;
			resetButton.visible = false;
		}
	}
	
	public void changePosOrRot(boolean position, String direction, boolean plus) {
		if(direction.equals("scale")) {
			if(plus && scaleButton.value <= 0.99d) {
				scaleButton.setSliderValue(scaleButton.value + 0.005d);
			}else if(!plus && scaleButton.value >= 0.01d) {
				scaleButton.setSliderValue(scaleButton.value - 0.005d);
			}
			
		}else if(position) {
			//change slider values
			if(plus) {
				if(direction.equals("x") && posx.value <= 0.99d) {
					posx.setSliderValue(posx.value + 0.005d);
				}else if(direction.equals("y") && posy.value <= 0.99d) {
					posy.setSliderValue(posy.value + 0.005d);
				}else if(direction.equals("z") && posz.value <= 0.99d) {
					posz.setSliderValue(posz.value + 0.005d);
				}
			}else {
				if(direction.equals("x") && posx.value >= 0.01d) {
					posx.setSliderValue(posx.value - 0.005d);
				}else if(direction.equals("y") && posy.value >= 0.01d) {
					posy.setSliderValue(posy.value - 0.005d);
				}else if(direction.equals("z") && posz.value >= 0.01d) {
					posz.setSliderValue(posz.value - 0.005d);
				}
			}
			
		}else {
			//change slider values
			if(plus) {
				if(direction.equals("x") && rotx.value <= 0.99d) {
					rotx.setSliderValue(rotx.value + 0.0025d);
				}else if(direction.equals("y") && roty.value <= 0.99d) {
					roty.setSliderValue(roty.value + 0.0025d);
				}else if(direction.equals("z") && rotz.value <= 0.99d) {
					rotz.setSliderValue(rotz.value + 0.0025d);
				}
			}else {
				if(direction.equals("x") && rotx.value >= 0.01d) {
					rotx.setSliderValue(rotx.value - 0.0025d);
				}else if(direction.equals("y") && roty.value >= 0.01d) {
					roty.setSliderValue(roty.value - 0.0025d);
				}else if(direction.equals("z") && rotz.value >= 0.01d) {
					rotz.setSliderValue(rotz.value - 0.0025d);
				}
			}
		}
		
		setData();
		
//		if(ModUtils.stringContains(selectedText, ",")) {
//			String name = StringUtils.substringBefore(selectedText, ",");
//			String[] txtArray = selectedText.split(",");
//			
//			if(ModUtils.arrayExist(txtArray, 8)) {
////				String name = txtArray[0];
//				int x = 0;
//				if(NumberUtils.isNumber(txtArray[1])) {
//					x = NumberUtils.createInteger(txtArray[1]);
//				}
//				int y = 0;
//				if(NumberUtils.isNumber(txtArray[2])) {
//					y = NumberUtils.createInteger(txtArray[2]);
//				}
//				int z = 0;
//				if(NumberUtils.isNumber(txtArray[3])) {
//					z = NumberUtils.createInteger(txtArray[3]);
//				}
//				int xrot = 0;
//				if(NumberUtils.isNumber(txtArray[4])) {
//					xrot = NumberUtils.createInteger(txtArray[4]);
//				}
//				int yrot = 0;
//				if(NumberUtils.isNumber(txtArray[5])) {
//					yrot = NumberUtils.createInteger(txtArray[5]);
//				}
//				int zrot = 0;
//				if(NumberUtils.isNumber(txtArray[6])) {
//					zrot = NumberUtils.createInteger(txtArray[6]);
//				}
//				int scale = 0;
//				if(NumberUtils.isNumber(txtArray[7])) {
//					scale = NumberUtils.createInteger(txtArray[7]);
//				}
//				
//				
//			}
//		}
	}
	
//	public void setAttachment(int slot, String string) {
//		
//	}
//	
//	public void changeSlotMover(int slot, int id, String containedstr) {
//		
//	}
	

	@Override
	public void func_146281_b() {
		close();
		super.func_146281_b();
	}
	
	public void close() {
		if(ModUtils.stringExist(ClientOnlyForgeSetup.uniqueItemDisplay)) {
			ConfigHelper.set("uniqueitems", ConfigHelper.uniqueItemDisplay = ClientOnlyForgeSetup.uniqueItemDisplay);
		}else {
			ClientOnlyForgeSetup.uniqueItemDisplay = "empty";
			ConfigHelper.set("uniqueitems", ConfigHelper.uniqueItemDisplay = "empty");
		}
		
		if(WeaponMasterMod.isMultiplayer) {
			Networking.sendToServer(new UniqueItemSettingsSPacket(ClientOnlyForgeSetup.uniqueItemDisplay));
		}
		selectedText = "";
	}
	
	@Override
	protected void func_73869_a(char p_96553_, int p_96552_) throws IOException  {
		if(SharedConstants.isAllowedCharacter(p_96553_) && textFocused) {
			text += p_96553_;
			text = SharedConstants.filterAllowedCharacters(text).toLowerCase();
			if(ModUtils.stringContains(text, " ")) {
				text = text.replace(" ", "");
			}
//			if(ModUtils.stringContains(text, "-")) {
//				text = text.replace("-", "");
//			}
			if(ModUtils.stringContains(text, ",")) {
				text = text.replace(",", "");
			}
			GuiHelper.playClickSound();
		}
		
		if(p_96552_ == 28 && textFocused && ModUtils.stringExist(text)) { //enter
			addText();
			GuiHelper.playClickSound();
			
		}else if(KeyHelper.isSelectAll(p_96552_) && ModUtils.stringExist(text)) { //select all
			selectText = true;
			
		}else if(KeyHelper.isCopy(p_96552_) && ModUtils.stringExist(text) && selectText) { //copy selected
			setClipboard(text);
			
		}else if(KeyHelper.isCut(p_96552_) && ModUtils.stringExist(text)) { //cut selected
			setClipboard(text);
			text = "";
			
		}else if(KeyHelper.isPaste(p_96552_)) { //cut selected
			if(selectText) {
				text = getClipboard();
			}else {
				text += getClipboard();
			}
		}else {
			if(selectText && ModUtils.stringExist(text)) {
				text = "";
			}
			if(ModUtils.stringExist(text) && textFocused) {
				if(p_96552_ == Keyboard.KEY_BACK || p_96552_ == Keyboard.KEY_DELETE) { //backspace -> delete
					if(selectText) {
						this.text = "";
					}else {
						this.text = text.substring(0, text.length() - 1);
						
					}
					GuiHelper.playClickSound();
				}
			}else {
				if(p_96552_ == KeyHandler.OPEN_SCREEN.func_151463_i() && !textFocused) {
					close();
					Minecraft.func_71410_x().func_147108_a(new DetailedSettingsScreen(DetailedSettingsScreen.selectedScreen));
				}
			}
			selectText = false;
		}
		super.func_73869_a(p_96553_, p_96552_);
	}
	
	public void addText() {
		if(ModUtils.stringExist(text) && !ModUtils.stringEquals(text, "empty")) {
			try {
			ClientOnlyForgeSetup.uniqueItemDisplay = ClientOnlyForgeSetup.uniqueItemDisplay+" "+text+",0,0,0,0,0,0,0,1";
			textFromConfig = ClientOnlyForgeSetup.uniqueItemDisplay;
			text = "";
			
			}catch (Exception e) {}
		}
	}
	
	public static void setClipboard(String p_95157_) {
		func_146275_d(p_95157_);
	}
	
	public static String getClipboard() {
		return func_146277_j().replaceAll("\\r", "");
	}
	
//////////////////////////////////////////render functions////////////////////////////////////////////////////////////////////////////////////////////////////////////
	@Override
	public void func_73863_a(int p_281550_, int p_282878_, float p_282465_) {
		GlStateManager.func_179094_E();
		this.func_73733_a(0, 0, this.field_146294_l, this.field_146295_m, -1072689136, -804253680);
		ITextComponent type = new TextComponentTranslation(WeaponMasterMod.MODID+".screen4");
		GuiHelper.drawString(field_146289_q, type, (int) ((field_146294_l/2)) - field_146289_q.func_78256_a(type.func_150254_d())/2, 30, Integer.parseInt("ffffff", 16), false);  
		
		type = new TextComponentString(text);
		int posx = ((field_146294_l/2) -5) - field_146289_q.func_78256_a(type.func_150254_d())/2;
		int posy = 50;
		
		if(selectText) {
			this.func_73733_a(posx + 5, posy, posx + field_146289_q.func_78256_a(type.func_150254_d()) + 5, posy + 20, -1072689136, -804253680);
		}
		this.func_73733_a(posx, posy, posx + field_146289_q.func_78256_a(type.func_150254_d()) + 10, posy + 20, -1072689136 * (textFocused? -1: 1), -804253680 * (textFocused? -1: 1));

		GuiHelper.drawString(field_146289_q, type, ((field_146294_l/2)) - field_146289_q.func_78256_a(type.func_150254_d())/2, posy + 5, Integer.parseInt("ffffff", 16), false);  
		
		if(ModUtils.stringContains(textFromConfig, " ")) {
			String[] txtArray = textFromConfig.split(" ");
			int line = 0;
			int maxposy = field_146295_m/20;
			
			for(int i = hoverValue; i < txtArray.length; i++) {
				if(ModUtils.stringContains(txtArray[i], ",")) {
					if(i+1 > (maxposy * 2)+1+hoverValue) {
						break;
					}
					String name = StringUtils.substringBefore(txtArray[i], ",");
					
					if(!ModUtils.stringEquals(name, "empty")) {
						posx = field_146294_l - field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()) - 5;
						posy = (line*20) + 5;
						
						this.func_73734_a(posx - 3, posy - 4, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+12, FastColor.ARGB32.color(255, 18, 3, 19));
						this.func_73734_a(posx - 4, posy - 3, 4 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 18, 3, 19));
						this.func_73734_a(posx - 3, posy - 3, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 37, 2, 93));
						this.func_73734_a(posx - 2, posy - 2, 2 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+10, FastColor.ARGB32.color(255, 18, 3, 19));
						
						
						GuiHelper.drawString(field_146289_q, name, posx, posy, Integer.parseInt("ffffff", 16), false);  

						line++;
					}
				}
			}
			
			//draw down arrow
			if(txtArray.length > maxposy) {
				String s = new TextComponentTranslation(WeaponMasterMod.MODID+".screen.shiftscroll").func_150254_d();
				int tempx = field_146294_l/2 - field_146289_q.func_78256_a(s) / 2;
				int tempy = field_146295_m - 11;
				
				this.func_73734_a(tempx - 3, tempy - 4, 3 + tempx + field_146289_q.func_78256_a(new TextComponentString(s).func_150254_d()), tempy+12, FastColor.ARGB32.color(255, 18, 3, 19));
				GuiHelper.drawString(field_146289_q, s, tempx, tempy, Integer.parseInt("ffffff", 16), false);  
			}
			
		}else if(ModUtils.stringExist(textFromConfig) && !ModUtils.stringEquals(textFromConfig, "empty")) {
			if(ModUtils.stringContains(textFromConfig, ",")) {
				String name = StringUtils.substringBefore(textFromConfig, ",");
				
				if(!ModUtils.stringEquals(name, "empty")) {
					posx = field_146294_l - field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()) - 5;
					posy = 5;
					
					this.func_73734_a(posx - 3, posy - 4, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+12, FastColor.ARGB32.color(255, 18, 3, 19));
					this.func_73734_a(posx - 4, posy - 3, 4 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 18, 3, 19));
					this.func_73734_a(posx - 3, posy - 3, 3 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+11, FastColor.ARGB32.color(255, 37, 2, 93));
					this.func_73734_a(posx - 2, posy - 2, 2 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()), posy+10, FastColor.ARGB32.color(255, 18, 3, 19));
					
					GuiHelper.drawString(field_146289_q, name, posx, posy, Integer.parseInt("ffffff", 16), false);  
				}
			}
		}
		
		//is a name is selected
		if(ModUtils.stringContains(selectedText, ",")) {
			String name = StringUtils.substringBefore(selectedText, ",");
			if(!ModUtils.stringEquals(name, "empty")) {
				GlStateManager.func_179094_E();
				posx = 72; //22
				posy = 55; //30

				this.func_73734_a(posx - 11 - field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d())/2, posy - 6, 11 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d())/2, posy+16, FastColor.ARGB32.color(255, 0, 0, 0));
				this.func_73734_a(posx - 10 - field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d())/2, posy - 5, 10 + posx + field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d())/2, posy+15, FastColor.ARGB32.color(255, 24, 25, 28));
				GuiHelper.drawString(field_146289_q, name, posx - field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d())/2, posy + 1, Integer.parseInt("ffffff", 16), false);  

				GlStateManager.func_179121_F();
				visible(true);
			}else{
				visible(false);
			}
		}else {
			visible(false);
		}
		
		super.func_73863_a(p_281550_, p_282878_, p_282465_);
		Minecraft mc = Minecraft.func_71410_x();
		
		if(normalbuttons.visible) {
			normalbuttons.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(resetButton.visible) {
			resetButton.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(removeButton.visible) {
			removeButton.func_146112_a(mc, p_281550_, p_282878_);
		}
		
		if(this.posx.visible) {
			this.posx.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.posy.visible) {
			this.posy.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.posz.visible) {
			this.posz.func_146112_a(mc, p_281550_, p_282878_);
		}
		
		if(this.rotx.visible) {
			this.rotx.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.roty.visible) {
			this.roty.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.rotz.visible) {
			this.rotz.func_146112_a(mc, p_281550_, p_282878_);
		}
		
		if(this.scaleButton.visible) {
			this.scaleButton.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.scalePlus.visible) {
			this.scalePlus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.scaleMinus.visible) {
			this.scaleMinus.func_146112_a(mc, p_281550_, p_282878_);
		}
		
		if(this.posxplus.visible) {
			this.posxplus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.posyplus.visible) {
			this.posyplus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.poszplus.visible) {
			this.poszplus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.rotxplus.visible) {
			this.rotxplus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.rotyplus.visible) {
			this.rotyplus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.rotzplus.visible) {
			this.rotzplus.func_146112_a(mc, p_281550_, p_282878_);
		}
		
		if(this.posxminus.visible) {
			this.posxminus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.posyminus.visible) {
			this.posyminus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.poszminus.visible) {
			this.poszminus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.rotxminus.visible) {
			this.rotxminus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.rotyminus.visible) {
			this.rotyminus.func_146112_a(mc, p_281550_, p_282878_);
		}
		if(this.rotzminus.visible) {
			this.rotzminus.func_146112_a(mc, p_281550_, p_282878_);
		}
		
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			if(this.slotButton[i].visible) {
				this.slotButton[i].func_146112_a(mc, p_281550_, p_282878_);
			}
		}
		
		WeaponMasterScreen.renderEntityInInventory(field_146294_l/2, field_146295_m/2 , 60 + DetailedSettingsScreen.scale, 0, 0, Minecraft.func_71410_x().field_71439_g);
	
		GlStateManager.func_179121_F();
	}
	
	
	public void renderBackground(int p_299421_, int p_298679_, float p_297268_) {}
	
//////////////////////////////////////////mouse functions////////////////////////////////////////////////////////////////////////////////////////////////////////////
	public boolean isMouseOverArea(double mouseX, double mouseY, int posX, int posY, int sizeX, int sizeY) {
		return (mouseX >= posX && mouseX < posX + sizeX && mouseY >= posY && mouseY < posY + sizeY);
	}

	@Override
	protected void func_73864_a(int p_94695_, int p_94696_, int p_94697_) throws IOException {
		//text from config
		if(ModUtils.stringContains(textFromConfig, " ")) {
			String[] txtArray = textFromConfig.split(" ");
			
			int line = 0;
			int maxposy = field_146295_m/20;
			
			for(int i = hoverValue; i < txtArray.length; i++) {
				if(i+1 > (maxposy)+1+hoverValue) {
					break;
				}
				
				if(ModUtils.stringContains(txtArray[i], ",")) {
					String name = StringUtils.substringBefore(txtArray[i], ",");
					
					int tempposx = field_146294_l - field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()) - 8;
					int tempposy = (line*20) + 1;

					if(!ModUtils.stringEquals(txtArray[i], "empty") && !ModUtils.stringEquals(name, "empty")) {
						if(isMouseOverArea(p_94695_, p_94696_, tempposx, tempposy, field_146289_q.func_78256_a(txtArray[i]) + 8, 17)) {
							//select text
							selectedText = txtArray[i];
							changeTheValuesOfTheButtons();
							GuiHelper.playClickSound();
						}
						
						line++;
					}
					
					
				}
			}
			
		}else if(ModUtils.stringExist(textFromConfig)) {
			if(ModUtils.stringContains(textFromConfig, ",")) {
				String name = StringUtils.substringBefore(textFromConfig, ",");
				
				if(!ModUtils.stringEquals(textFromConfig, "empty") && !ModUtils.stringEquals(name, "empty")) {
					int tempposx = field_146294_l - field_146289_q.func_78256_a(new TextComponentString(name).func_150254_d()) - 5;
					int tempposy = 1;
					
					if(isMouseOverArea(p_94695_, p_94696_, tempposx, tempposy, field_146289_q.func_78256_a(textFromConfig) + 8, 17) && !ModUtils.stringEquals(textFromConfig, "empty")) {
						selectedText = textFromConfig;
						changeTheValuesOfTheButtons();
						GuiHelper.playClickSound();
					}
				}
			}
		}
		
		ITextComponent type = new TextComponentString(text);
		int posx = ((field_146294_l/2) -5) - field_146289_q.func_78256_a(type.func_150254_d())/2;
		int posy = 50;
		
		if(isMouseOverArea(p_94695_, p_94696_, posx, posy, field_146289_q.func_78256_a(type.func_150254_d()) + 10, 20)) {
			textFocused = true;
			GuiHelper.playClickSound();
		}else {
			textFocused = false;
			selectText = false;
		}
		if(isMouseOverArea(p_94695_, p_94696_, 0, 0, field_146294_l, field_146295_m) &&
				!isMouseOverArea(p_94695_, p_94696_, 0, 50, 140, 135)) {
			this.draggingPlayerMode = true;
			ClientOnlyForgeSetup.xPos = (int) Math.floor(p_94695_);
			ClientOnlyForgeSetup.yPos = (int) Math.floor(p_94696_);
			ClientOnlyForgeSetup.fakexRot = ClientOnlyForgeSetup.xRot;
			ClientOnlyForgeSetup.fakeyRot = ClientOnlyForgeSetup.yRot;
		}
		
		super.func_73864_a(p_94695_, p_94696_, p_94697_);
	}

	public void setValues(NewForgeSlider b, double v) {
		double minValue = v - 100;
		double maxValue = v + 100;
		
		if(b == scaleButton) {
			minValue = -100;
			maxValue = 100;
		}
		if(b == rotx || b == roty || b == rotz) {
			minValue = -180;
			maxValue = 180;
		}
		b.minValue = minValue;
		b.maxValue = maxValue;
		b.value = b.snapToNearest((v - b.minValue) / (b.maxValue - b.minValue));
		
		b.updateMessage();
	}
	
	public void changeTheValuesOfTheButtons() {
		if(ModUtils.stringContains(selectedText, ",")) {
			String[] txtArray = selectedText.split(",");
			
			if(ModUtils.arrayExist(txtArray, 9)) {
//				String name = txtArray[0];
				int x = 0;
				if(NumberUtils.isNumber(txtArray[1])) {
					x = NumberUtils.createInteger(txtArray[1]);
				}
				int y = 0;
				if(NumberUtils.isNumber(txtArray[2])) {
					y = NumberUtils.createInteger(txtArray[2]);
				}
				int z = 0;
				if(NumberUtils.isNumber(txtArray[3])) {
					z = NumberUtils.createInteger(txtArray[3]);
				}
				int xrot = 0;
				if(NumberUtils.isNumber(txtArray[4])) {
					xrot = NumberUtils.createInteger(txtArray[4]);
				}
				int yrot = 0;
				if(NumberUtils.isNumber(txtArray[5])) {
					yrot = NumberUtils.createInteger(txtArray[5]);
				}
				int zrot = 0;
				if(NumberUtils.isNumber(txtArray[6])) {
					zrot = NumberUtils.createInteger(txtArray[6]);
				}
				int scale = 0;
				if(NumberUtils.isNumber(txtArray[7])) {
					scale = NumberUtils.createInteger(txtArray[7]);
				}
				
				setValues(posx, x);
				setValues(posy, y);
				setValues(posz, z);
				setValues(rotx, xrot);
				setValues(roty, yrot);
				setValues(rotz, zrot);
				setValues(scaleButton, scale);
				
				for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
					if(ModUtils.stringContains(txtArray[8], String.valueOf(i+1))) {
						selectSlot(i);
						break;
					}else if(ModUtils.stringContains(txtArray[8], "shield") && i == 9) {
						selectSlot(i);
						break;
					}else if(ModUtils.stringContains(txtArray[8], "banner") && i == 10) {
						selectSlot(i);
						break;
					}else if(ModUtils.stringContains(txtArray[8], "offhand") && i == 11) {
						selectSlot(i);
						break;
					}else if(ModUtils.stringContains(txtArray[8], "quiver") && i == 12) {
						selectSlot(i);
						break;
					}
				}
				
				
//				String attachment = txtArray[8];
//				String moveDataText = txtArray[9];
//				String[] allMoveData = new String[3];
//				String[] moveFromSlot = new String[WeaponMasterMod.maxDisplaySlotNum];
//				int xyzMover = 0;
//				int plusOrMinus = 0;
//				
//				//move from active slots
//				if(ModUtils.stringContains(moveDataText, ";")) {
//					String[] temp = moveDataText.split(";");
//					
//					if(ModUtils.arrayExist(temp, 3)) {
//						allMoveData = temp;
//						
//						if(ModUtils.stringContains(allMoveData[0], ",")) {
//							String[] tempTxt = allMoveData[0].split(",");
//							moveFromSlot = tempTxt;
//							
//							for(int i = 0; i < tempTxt.length; i++) {
//								if(!ModUtils.stringExist(moveFromSlot[i])) {
//									moveFromSlot[i] = "none";
//								}
//							}
//							
//						}else if(ModUtils.stringExist(allMoveData[0])){
//							String[] tempTxt = {allMoveData[0]};
//							moveFromSlot = tempTxt;
//									
//						}else if(allMoveData[0] == null){
//							allMoveData[0] = "none";
//							String[] tempTxt = {allMoveData[0]};
//							moveFromSlot = tempTxt;
//						}
//						
//						//xyz mover
//						if(ModUtils.stringExist(temp[1])) {
//							if(temp[1].equals("x")) {
//								x = 0;
//							}else if(temp[1].equals("y")) {
//								x = 1;
//							}else if(temp[1].equals("z")) {
//								x = 2;
//							}
//						}
//						
//						//plus-minus mover
//						if(ModUtils.stringExist(temp[2])) {
//							if(temp[2].equals("+")) {
//								plusOrMinus = 0;
//							}else if(temp[2].equals("-")) {
//								plusOrMinus = 1;
//							}
//						}
//						
//						
//						//change the values of the buttons TODO
//						//remove
//						//save
//						
//						//x,y,z, xrot, yrot, zrot
//						//modify position buttons (slot, armor, xyz +-)
//						
////						helm chest legs boots
//						if(ModUtils.stringContains(moveDataText, "helm")) {
//							helmet.toggle = true;
//							chestplate.toggle = false;
//							legs.toggle = false;
//							boots.toggle = false;
//						}else if(ModUtils.stringContains(moveDataText, "chest")) {
//							helmet.toggle = false;
//							chestplate.toggle = true;
//							legs.toggle = false;
//							boots.toggle = false;
//						}else if(ModUtils.stringContains(moveDataText, "legs")) {
//							helmet.toggle = false;
//							chestplate.toggle = false;
//							legs.toggle = true;
//							boots.toggle = false;
//						}else if(ModUtils.stringContains(moveDataText, "boots")) {
//							helmet.toggle = false;
//							chestplate.toggle = false;
//							legs.toggle = false;
//							boots.toggle = true;
//						}
//						
//						//xyz
//						if(xyzMover == 0) {
//							slotMoverX.toggle = true;
//							slotMoverY.toggle = false;
//							slotMoverZ.toggle = false;
//						}else if(xyzMover == 1) {
//							slotMoverX.toggle = false;
//							slotMoverY.toggle = true;
//							slotMoverZ.toggle = false;
//						}else if(xyzMover == 2) {
//							slotMoverX.toggle = false;
//							slotMoverY.toggle = false;
//							slotMoverZ.toggle = true;
//						}
//
//						//plus minus
//						if(plusOrMinus == 0) {
//							slotMoverMinus.toggle = false;
//							slotMoverPlus.toggle = true;
//						}else if(plusOrMinus == 1) {
//							slotMoverMinus.toggle = true;
//							slotMoverPlus.toggle = false;
//						}
//						
//						//attach to buttons (head, body, larm, rarm, lleg, rleg) OK
//						if(ModUtils.stringEquals(attachment, "head")) {
//							toggleAttachmentButtons(0);
//						}else if(ModUtils.stringEquals(attachment, "body")) {
//							toggleAttachmentButtons(1);
//						}else if(ModUtils.stringEquals(attachment, "rarm")) {
//							toggleAttachmentButtons(2);
//						}else if(ModUtils.stringEquals(attachment, "larm")) {
//							toggleAttachmentButtons(3);
//						}else if(ModUtils.stringEquals(attachment, "rleg")) {
//							toggleAttachmentButtons(4);
//						}else if(ModUtils.stringEquals(attachment, "lleg")) {
//							toggleAttachmentButtons(5);
//						}
//					}
//				}
			}
		}
	}
	
//	public void toggleAttachmentButtons(int s) {
//		for(int i = 0; i < 6; i++) {
//			if(i == s) {
//				attachmentButton[s].toggle = true;
//			}else {
//				attachmentButton[s].toggle = false;
//			}
//		}
//	}

	@Override
	protected void func_146286_b(int p_94722_, int p_94723_, int p_94724_) {
		if(this.draggingPlayerMode) {
			this.draggingPlayerMode = false;
		}
		if(shiftDown) {
			shiftDown = false;
		}
		super.func_146286_b(p_94722_, p_94723_, p_94724_);
	}
	
	@Override
	public void func_146274_d() throws IOException {
		super.func_146274_d();
		int p_94689_ = Integer.signum(Mouse.getEventDWheel());
		
		if(!KeyHelper.hasShiftDown()) {
			if(p_94689_ < 0 && p_94689_ + DetailedSettingsScreen.scale < -60) {
				DetailedSettingsScreen.scale = -60;
			}else if(p_94689_ > 0 && p_94689_ + DetailedSettingsScreen.scale > 160) {
				DetailedSettingsScreen.scale = 160;
			}else {
				DetailedSettingsScreen.scale += p_94689_*2;
			}
		}else {
			if(ModUtils.stringContains(textFromConfig, " ")) {
				String[] txtArray = textFromConfig.split(" ");
				
				if(hoverValue + p_94689_*-1 > 0 && hoverValue + p_94689_*-1 + ((field_146295_m/20)) <= txtArray.length) {
					hoverValue += p_94689_*-1;
				}else if(hoverValue + p_94689_*-1 + ((field_146295_m/20)) > txtArray.length){
					hoverValue = txtArray.length - ((field_146295_m/20)) < 0 ? 0 : txtArray.length - ((field_146295_m/20));
				}
			}
		}
	}
	
	@Override
	protected void func_146273_a(int mouseX, int mouseY, int clickedMouseButton, long timeSinceLastClick) {
		if(this.draggingPlayerMode) {
			ClientOnlyForgeSetup.xRot = ClientOnlyForgeSetup.fakexRot - (int) (mouseX - ClientOnlyForgeSetup.xPos);
			ClientOnlyForgeSetup.yRot = ClientOnlyForgeSetup.fakeyRot - (int) (mouseY - ClientOnlyForgeSetup.yPos);
			
			if(ClientOnlyForgeSetup.xRot >= 360) {
				ClientOnlyForgeSetup.xRot -= 360;
			}else if(ClientOnlyForgeSetup.xRot <= -360) {
				ClientOnlyForgeSetup.xRot += 360;
			}
			if(ClientOnlyForgeSetup.yRot >= 360) {
				ClientOnlyForgeSetup.yRot -= 360;
			}else if(ClientOnlyForgeSetup.yRot <= -360) {
				ClientOnlyForgeSetup.yRot += 360;
			}
		}
		super.func_146273_a(mouseX, mouseY, clickedMouseButton, timeSinceLastClick);
	}
	
	public static void setData() {
		if(ModUtils.stringContains(selectedText, ",")) {
			String slot = "1";
			
			for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
				if(slotButton[i].toggle) {
					if(i < 9) {
						slot = String.valueOf(i+1);
					}else if(i == 9) {
						slot = "shield";
					}else if(i == 10) {
						slot = "banner";
					}else if(i == 11) {
						slot = "offhand";
					}else if(i == 12) {
						slot = "quiver";
					}
				}
			}
			
			String name = StringUtils.substringBefore(selectedText, ",");
			String newtext = name+","+
					posx.getValueInt()+","+
					posy.getValueInt()+","+
					posz.getValueInt()+","+
					rotx.getValueInt()+","+
					roty.getValueInt()+","+
					rotz.getValueInt()+","+
					scaleButton.getValueInt()+","+
					slot;
			
			if(ModUtils.stringContains(ClientOnlyForgeSetup.uniqueItemDisplay, " ")) {
				String[] txtArray = ClientOnlyForgeSetup.uniqueItemDisplay.split(" ");
				String temptxt = "";
				String tempslot = "-1";
				String[] selectedArray = selectedText.split(",");
				
				if(ModUtils.arrayExist(selectedArray, 9)) {
					if(ModUtils.stringExist(selectedArray[8])) {
						tempslot = selectedArray[8];
					}
				}
				
				boolean found = false;
				
				for(int i = 0; i < txtArray.length; i++) {
					if(ModUtils.stringContains(txtArray[i], ",")) {
						String[] data = txtArray[i].split(",");
						
						if(ModUtils.arrayExist(data, 9)) {
							if(ModUtils.stringExist(temptxt)) {
								temptxt+=" ";
							}
							
							if(!found && ModUtils.stringContains(data[0], name) && ModUtils.stringEquals(data[8], tempslot)) { //name and slot name
								temptxt += newtext;
								found = true;
							}else {
								temptxt += txtArray[i];
							}
						}
					}
				}
				
				try {
				selectedText = newtext;
				ClientOnlyForgeSetup.uniqueItemDisplay = temptxt;
				}catch (Exception e) {}
			}else {
				try {
				selectedText = newtext;
				ClientOnlyForgeSetup.uniqueItemDisplay = newtext;
				}catch (Exception e) {}
			}
			textFromConfig = ClientOnlyForgeSetup.uniqueItemDisplay;
		}
	}
}
