package com.minecraftserverzone.weaponmaster.renderer.quiver;

import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelBox;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;

// Made with Blockbench 4.9.2
// Exported for Minecraft version 1.17 or later with Mojang mappings
// Paste this class into your mod and generate all required imports


public class QuiverWithArrowsModel <T extends Entity> extends ModelBase {
	// This layer location should be baked with EntityRendererProvider.Context in the entity renderer and passed into this model's constructor
	private final ModelRenderer quiver;
	private final ModelRenderer bone;
	private final ModelRenderer quiverbody_r1;
	private final ModelRenderer arrow;
	private final ModelRenderer arrow2;
	private final ModelRenderer arrow3;
	private final ModelRenderer arrow4;
	private final ModelRenderer arrow5;
	private final ModelRenderer arrow6;
	private final ModelRenderer arrow7;
	private final ModelRenderer arrow8;
	private final ModelRenderer arrow9;
	private final ModelRenderer arrow10;

	public QuiverWithArrowsModel(int w, int h) {
		field_78090_t = 64;
		field_78089_u = 64;

		quiver = new ModelRenderer(this);
		quiver.func_78793_a(0.0F, 5.0F, 5.5F);
		setRotationAngle(quiver, -0.0002F, 0.0F, 0.0F);
		

		bone = new ModelRenderer(this);
		bone.func_78793_a(0.0F, 0.0F, 0.0F);
		quiver.func_78792_a(bone);
		

		quiverbody_r1 = new ModelRenderer(this);
		quiverbody_r1.func_78793_a(0.0F, 0.0F, 0.0F);
		bone.func_78792_a(quiverbody_r1);
		setRotationAngle(quiverbody_r1, 0.0002F, 0.0F, 0.0F);
		quiverbody_r1.field_78804_l.add(new ModelBox(quiverbody_r1, 20, 51, -5.5F, 0.2F, -5.5F, 11, 2, 11, 0.0F, false));
		quiverbody_r1.field_78804_l.add(new ModelBox(quiverbody_r1, 20, 51, -5.5F, 0.2F, -5.5F, 11, 2, 11, 0.0F, false));
		quiverbody_r1.field_78804_l.add(new ModelBox(quiverbody_r1, 24, 0, -5.0F, -2.0F, -5.0F, 10, 18, 10, -0.25F, false));

		arrow = new ModelRenderer(this);
		arrow.func_78793_a(-4.2F, -5.5F, -4.2F);
		quiver.func_78792_a(arrow);
		setRotationAngle(arrow, 0.1309F, -0.2182F, 1.3526F);
		arrow.field_78804_l.add(new ModelBox(arrow, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow.field_78804_l.add(new ModelBox(arrow, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow.field_78804_l.add(new ModelBox(arrow, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow2 = new ModelRenderer(this);
		arrow2.func_78793_a(-4.5F, -6.5F, 4.5F);
		quiver.func_78792_a(arrow2);
		setRotationAngle(arrow2, -0.3491F, 0.2182F, 1.3526F);
		arrow2.field_78804_l.add(new ModelBox(arrow2, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow2.field_78804_l.add(new ModelBox(arrow2, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow2.field_78804_l.add(new ModelBox(arrow2, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow3 = new ModelRenderer(this);
		arrow3.func_78793_a(3.1F, -4.5F, -3.2F);
		quiver.func_78792_a(arrow3);
		setRotationAngle(arrow3, -0.48F, -0.1745F, 1.7453F);
		arrow3.field_78804_l.add(new ModelBox(arrow3, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow3.field_78804_l.add(new ModelBox(arrow3, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow3.field_78804_l.add(new ModelBox(arrow3, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow4 = new ModelRenderer(this);
		arrow4.func_78793_a(1.2F, -8.5F, -3.4F);
		quiver.func_78792_a(arrow4);
		setRotationAngle(arrow4, 0.0873F, -0.2182F, 1.7017F);
		arrow4.field_78804_l.add(new ModelBox(arrow4, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow4.field_78804_l.add(new ModelBox(arrow4, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow4.field_78804_l.add(new ModelBox(arrow4, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow5 = new ModelRenderer(this);
		arrow5.func_78793_a(5.2F, -6.5F, 4.4F);
		quiver.func_78792_a(arrow5);
		setRotationAngle(arrow5, -0.3927F, 0.1309F, 1.8326F);
		arrow5.field_78804_l.add(new ModelBox(arrow5, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow5.field_78804_l.add(new ModelBox(arrow5, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow5.field_78804_l.add(new ModelBox(arrow5, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow6 = new ModelRenderer(this);
		arrow6.func_78793_a(0.0F, -9.5F, 2.9F);
		quiver.func_78792_a(arrow6);
		setRotationAngle(arrow6, 0.0F, 0.1309F, 1.5272F);
		arrow6.field_78804_l.add(new ModelBox(arrow6, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow6.field_78804_l.add(new ModelBox(arrow6, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow6.field_78804_l.add(new ModelBox(arrow6, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow7 = new ModelRenderer(this);
		arrow7.func_78793_a(-5.2F, -5.5F, 0.3F);
		quiver.func_78792_a(arrow7);
		setRotationAngle(arrow7, 0.0F, 0.0436F, 1.2217F);
		arrow7.field_78804_l.add(new ModelBox(arrow7, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow7.field_78804_l.add(new ModelBox(arrow7, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow7.field_78804_l.add(new ModelBox(arrow7, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow8 = new ModelRenderer(this);
		arrow8.func_78793_a(-0.3F, -6.5F, 5.4F);
		quiver.func_78792_a(arrow8);
		setRotationAngle(arrow8, 0.1745F, 0.3491F, 1.6144F);
		arrow8.field_78804_l.add(new ModelBox(arrow8, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow8.field_78804_l.add(new ModelBox(arrow8, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow8.field_78804_l.add(new ModelBox(arrow8, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow9 = new ModelRenderer(this);
		arrow9.func_78793_a(6.2F, -6.5F, -0.6F);
		quiver.func_78792_a(arrow9);
		setRotationAngle(arrow9, 0.0873F, -0.0436F, 2.0508F);
		arrow9.field_78804_l.add(new ModelBox(arrow9, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow9.field_78804_l.add(new ModelBox(arrow9, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow9.field_78804_l.add(new ModelBox(arrow9, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));

		arrow10 = new ModelRenderer(this);
		arrow10.func_78793_a(-2.0F, -9.5F, -1.7F);
		quiver.func_78792_a(arrow10);
		setRotationAngle(arrow10, 0.5672F, -0.1745F, 1.3963F);
		arrow10.field_78804_l.add(new ModelBox(arrow10, 0, 0, -1.0F, -2.5F, 0.0F, 16, 5, 0, 0.0F, false));
		arrow10.field_78804_l.add(new ModelBox(arrow10, 0, 0, 0.0F, -2.5F, -2.5F, 0, 5, 5, 0.0F, false));
		arrow10.field_78804_l.add(new ModelBox(arrow10, -5, 0, -1.0F, 0.0F, -2.5F, 16, 0, 5, 0.0F, false));
	}
	
	public void setRotationAngle(ModelRenderer ModelRenderer, float x, float y, float z) {
		ModelRenderer.field_78795_f = x;
		ModelRenderer.field_78796_g = y;
		ModelRenderer.field_78808_h = z;
	}
	
	public void setupAnim(int arrowStackSize, Entity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
		if(entity instanceof EntityPlayer) {
			int i = 0;
			arrow.field_78806_j = arrowStackSize > i;i++;
			arrow2.field_78806_j = arrowStackSize > i;i++;
			arrow3.field_78806_j = arrowStackSize > i;i++;
			arrow4.field_78806_j = arrowStackSize > i;i++;
			arrow5.field_78806_j = arrowStackSize > i;i++;
			arrow6.field_78806_j = arrowStackSize > i;i++;
			arrow7.field_78806_j = arrowStackSize > i;i++;
			arrow8.field_78806_j = arrowStackSize > i;i++;
			arrow9.field_78806_j = arrowStackSize > i;i++;
			arrow10.field_78806_j = arrowStackSize > i;
		}
	}
	
	@Override
	public void func_78088_a(Entity entityIn, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scale) {
		GlStateManager.func_179094_E();
		GlStateManager.func_179139_a(0.0625d, 0.0625d, 0.0625d);
		quiver.func_78785_a(scale);
		super.func_78088_a(entityIn, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale);
		GlStateManager.func_179121_F();
	}
}
