package com.minecraftserverzone.weaponmaster.setup.events_on_client;

import com.minecraftserverzone.weaponmaster.itemlayers.HumanoidItemLayer;
import com.minecraftserverzone.weaponmaster.setup.KeyHandler;

import net.minecraft.client.Minecraft;
import net.minecraftforge.fml.common.Mod.EventBusSubscriber;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.relauncher.Side;

@EventBusSubscriber(value = Side.CLIENT)
public class ClientOnlyModSetup {
	
	public static void init(FMLInitializationEvent event) {
		KeyHandler.register();
		addLayer();
	}
	
	public static void addLayer() {
		Minecraft.func_71410_x().func_152344_a(() -> {
			System.out.println("Weaponmaster add HumanoidItemLayer!");
			Minecraft.func_71410_x().func_175598_ae().getSkinMap().forEach((text, render)-> {
				render.func_177094_a(new HumanoidItemLayer(render));
			});
		});
		
		
//        RenderPlayer rend = Minecraft.getMinecraft().getRenderManager().getSkinMap().get("default");
//		rend.addLayer(new HumanoidItemLayer(rend));
//        
//        RenderPlayer rend2 = Minecraft.getMinecraft().getRenderManager().getSkinMap().get("slim");
//		rend.addLayer(new HumanoidItemLayer(rend2));
    }
}
