package com.minecraftserverzone.weaponmaster.setup.helper;

public class ModUtils {

	public static boolean arrayExist(String[] value, int minLength) {
		if(value != null) {
			if(value.length >= minLength) {
				return true;
			}
		}
		
		return false;
	}
	
	public static boolean arrayExist(String[] value, int minLength, int maxLength) {
		if(value != null) {
			if(value.length >= minLength && value.length <= maxLength) {
				return true;
			}
		}
		
		return false;
	}
	
	public static boolean stringExist(String value) {
		if(value != null) {
			if(value.length() > 0) {
				return true;
			}
		}
		
		return false;
	}
	
	
	public static boolean stringContains(String value, String contain) {
		if(value != null) {
			if(value.length() > 0) {
				if(contain != null) {
					if(contain.length() > 0) {
						if(value.contains(contain)) {
							return true;
						}
					}
				}
			}
		}
		
		return false;
	}
	
	public static String[] splitString(String value, String regex) {
		if(ModUtils.stringContains(value, regex)) {
			return value.split(regex);
		}
		
		return null;
	}

	public static boolean stringEquals(String value, String value2) {
		if(ModUtils.stringExist(value)) {
			if(value.equalsIgnoreCase(value2)) {
				return true;
			}
		}
		return false;
	}

	
}
