package com.minecraftserverzone.weaponmaster.setup;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;
import com.minecraftserverzone.weaponmaster.setup.events_on_client.ClientOnlyForgeSetup;

public class Helper {
	
	public static void setData() {
		try {
		for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
			String xpos = "x_position"+String.valueOf(i * 3);
			String ypos = "y_position"+String.valueOf((i * 3)+ 1);
			String zpos = "z_position"+String.valueOf((i * 3)+ 2);
			String xr = "x_rotation"+String.valueOf(i * 3);
			String yr = "y_rotation"+String.valueOf((i * 3)+ 1);
			String zr = "z_rotation"+String.valueOf((i * 3)+ 2);
			
			ConfigHelper.set(xpos, ConfigHelper.positions[(i * 3)] = ClientOnlyForgeSetup.slotPositions[i * 3]);
			ConfigHelper.set(ypos, ConfigHelper.positions[(i * 3)+ 1] = ClientOnlyForgeSetup.slotPositions[(i * 3)+ 1]);
			ConfigHelper.set(zpos, ConfigHelper.positions[(i * 3)+ 2] = ClientOnlyForgeSetup.slotPositions[(i * 3)+ 2]);
			
			ConfigHelper.set(xr, ConfigHelper.rotations[(i * 3)] = ClientOnlyForgeSetup.slotRotations[i * 3]);
			ConfigHelper.set(yr, ConfigHelper.rotations[(i * 3)+ 1] = ClientOnlyForgeSetup.slotRotations[(i * 3)+ 1]);
			ConfigHelper.set(zr, ConfigHelper.rotations[(i * 3)+ 2] = ClientOnlyForgeSetup.slotRotations[(i * 3)+ 2]);
			
			ConfigHelper.set("scale"+String.valueOf(i), ConfigHelper.scale[i] = ClientOnlyForgeSetup.scale[i]);
		}
		
		ConfigHelper.set("attachment", ConfigHelper.slot_attachment = ClientOnlyForgeSetup.slotAttachment);
		ConfigHelper.set("slot_mover", ConfigHelper.slotMover = ClientOnlyForgeSetup.slotMover);
		
		}catch (Exception e) {}
	}
}
