package com.minecraftserverzone.weaponmaster.setup.events_on_client;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.gui.WeaponMasterScreen;
import com.minecraftserverzone.weaponmaster.setup.KeyHandler;
import com.minecraftserverzone.weaponmaster.setup.configs.ConfigHelper;

import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.common.Mod.EventBusSubscriber;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.InputEvent.KeyInputEvent;
import net.minecraftforge.fml.common.gameevent.PlayerEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent.Phase;
import net.minecraftforge.fml.common.gameevent.TickEvent.PlayerTickEvent;
import net.minecraftforge.fml.relauncher.Side;

@EventBusSubscriber(value = Side.CLIENT)
public class ClientOnlyForgeSetup {
	
	public static int[] slotPositions = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
	public static int[] slotRotations = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
	public static int[] scale =  new int[WeaponMasterMod.maxDisplaySlotNum];
	public static int xRot, yRot, fakexRot, fakeyRot, xPos, yPos;
	public static String slotAttachment = "1-body,2-body,3-rleg,4-lleg,5-rleg,6-lleg,7-body,8-body,9-rleg,shield-body,banner-head,offhand-lleg,quiver-body";
	public static String slotMover = "none,chest;z;+_none,chest,1;z;+_none,legs;x;-_none,legs;x;+_none,legs,3;x;-_none,legs,4;x;+_none,chest,legs,1;z;+_none,shield;z;+_none,legs,3,5;x;-_none;z;-_none;z;-_none,legs,4,6;x;+_none;z;+";
	public static int hideTick;
	public static String uniqueItemDisplay;
	public static int lastMainhandHit = 1, lastOffhandHit = 1;
	public static String whitelist;
	public static String blacklist;

	@SubscribeEvent
	public static void loggedout(PlayerEvent.PlayerLoggedOutEvent event) {
		if(event.player == Minecraft.func_71410_x().field_71439_g) {
			WeaponMasterMod.isMultiplayer = false;
		}
	}
	
//	public static void handActionPacket(EntityPlayer player, boolean mainhand, int value) {
//		if(WeaponMasterMod.isMultiplayer) {
//			Networking.sendToServer(new HandActionSPacket(mainhand));
//		}
//	}
	
	@SubscribeEvent
	public static void playerTick(PlayerTickEvent event) {
		if(event.player == Minecraft.func_71410_x().field_71439_g && event.phase == Phase.END && event.player.field_70170_p.field_72995_K) {
			if(event.player.field_70173_aa == 10) {
				onServerJoin(event.player);
			}
//			if(event.player.isHandActive() && event.player.getActiveHand() == E.MAIN_HAND) {
//				lastMainhandHit = 1;
//			}else if(lastMainhandHit > 0 && lastMainhandHit <= hideTick) {
//				lastMainhandHit++;
//			}
//			
//			if(event.player.isHandActive() && event.player.getActiveHand() == Hand.OFF_HAND) {
//				lastOffhandHit = 1;
//			}else if(lastOffhandHit > 0 && lastOffhandHit <= hideTick) {
//				lastOffhandHit++;
//			}
		}
	}
	
//	@SubscribeEvent
//	public static void hit(InputEvent.MouseInputEvent event) {
//		//button: 0 -> left click		1 -> right click		2 -> middle click
//		//action: 0-> released			1 -> pressed
//		
//		if(Minecraft.getMinecraft().player != null && !Minecraft.getMinecraft().isGamePaused()) {
//			if(event.getAction() == 1) { //button is pressed
//				if(event.getButton() == 0) { //hit button - left click
//					lastMainhandHit = 1;
//					handActionPacket(Minecraft.getMinecraft().player, true, lastMainhandHit);
//					
////				}else if(event.getButton() == 1) { //block or use button - right click
////					lastOffhandHit = 1;
//				}
//			}
//		}
//	}
	
	@SubscribeEvent
	public static void keyPressed(KeyInputEvent event) {
		if(KeyHandler.OPEN_SCREEN.func_151470_d()) {
			Minecraft.func_71410_x().func_147108_a(new WeaponMasterScreen());
		}
//		if(Minecraft.getMinecraft().gameSettings.keyBindSwapHands.isKeyDown()) {
////			if(Minecraft.getMinecraft().player != null && !Minecraft.getMinecraft().isPaused()) {
////				if(Minecraft.getMinecraft().player.getUsedItemHand() != InteractionHand.MAIN_HAND) {
////					lastMainhandHit = 1;
////				}else {
////					lastOffhandHit = 1;
////				}
////			}
//		}
	}

//	@SubscribeEvent
	public static void onServerJoin(EntityPlayer player) {
//		event.getConnection().getRemoteAddress();
//		event.getPlayer().connection.getServerData().ip;		
		//send toggle data to server and server should send it to all client
		if(player == Minecraft.func_71410_x().field_71439_g) {
			for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum * 3; i++) {
				slotPositions[i] = ConfigHelper.positions[i];
				slotRotations[i] = ConfigHelper.rotations[i];
			}
			for(int i = 0; i < WeaponMasterMod.maxDisplaySlotNum; i++) {
				scale[i] = ConfigHelper.scale[i];
			}
			
			slotAttachment  = ConfigHelper.slot_attachment;
			slotMover  = ConfigHelper.slotMover;
			
			hideTick = ConfigHelper.hideTick;
			uniqueItemDisplay = ConfigHelper.uniqueItemDisplay;
			
			whitelist = ConfigHelper.whitelist;
			blacklist = ConfigHelper.blacklist;
		}
	}
}
