package com.minecraftserverzone.weaponmaster.setup.helper;

import com.ibm.icu.math.BigDecimal;

import net.minecraft.client.Minecraft;
import net.minecraft.client.audio.PositionedSoundRecord;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.Gui;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.init.SoundEvents;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.ITextComponent;

public class GuiHelper {
	
	/**Dark Blue*/  public static String cldb="\u00A71";	
	/**Dark Green*/ public static String cldg="\u00A72";	
	/**Aqua*/       public static String cla="\u00A73";	
	/**Dark Red*/   public static String cldr="\u00A74";	
	/**Dark Purple*/public static String cldp="\u00A75";	
	/**Gold*/       public static String clgd="\u00A76";	
	/**Gray*/       public static String clgy="\u00A77";	
	/**Dark Gray*/  public static String cldgy="\u00A78";	
	/**Blue*/       public static String clbe="\u00A79";	
	/**Black*/      public static String clb="\u00A70";	
	/**Light Green*/public static String cllg="\u00A7a";	
	/**Light Blue*/ public static String cllb="\u00A7b";	
	/**Light Red*/  public static String cllr="\u00A7c";	
	/**Purple*/     public static String clpr="\u00A7d";	
	/**Yellow*/     public static String cly="\u00A7e";	
	/**White*/      public static String clw="\u00A7f";	
	
	public static void playClickSound() {
		Minecraft.func_71410_x().func_147118_V().func_147682_a(PositionedSoundRecord.func_184371_a(SoundEvents.field_187909_gi, 1.0F));
	}
	
	public static void blit(Gui gui, ResourceLocation loc, int x, int y, int uOffset, int vOffset, int uWidth, int vHeight) {
		Minecraft.func_71410_x().func_110434_K().func_110577_a(loc);
	    GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0f);
	     
	    gui.func_73729_b(x, y, uOffset, vOffset, uWidth, vHeight);
	}

	public static void drawString(FontRenderer font, ITextComponent type, int x, int y, int color, boolean shadow) {
		if(shadow) {
			font.func_175063_a(type.func_150254_d(), x, y, color);
		}else {
			font.func_78276_b(type.func_150254_d(), x, y, color);
		}
	}
	
	public static void drawString(FontRenderer font, String type, int x, int y, int color, boolean shadow) {
		if(shadow) {
			font.func_175063_a(type, x, y, color);
		}else {
			font.func_78276_b(type, x, y, color);
		}
	}
	
	private static void bind(ResourceLocation res)
    {
		Minecraft.func_71410_x().func_110434_K().func_110577_a(res);
    }

	public static float round(float d, int decimalPlace) {  
        return round(d,decimalPlace, BigDecimal.ROUND_HALF_UP);   
    }
	
	public static float round(float d, int decimalPlace, int rm) {
        BigDecimal bd = new BigDecimal(Float.toString(d));
        bd = bd.setScale(decimalPlace, rm);    
        return bd.floatValue();   
    }
	
	public static double round(double d, int decimalPlace) {  
        return round(d,decimalPlace,BigDecimal.ROUND_HALF_UP);   
    }
	
	public static double round(double d, int decimalPlace, int rm) {
        BigDecimal bd = new BigDecimal(Double.toString(d));
        bd = bd.setScale(decimalPlace, rm);    
        return bd.doubleValue();   
    }
}
