package com.minecraftserverzone.weaponmaster.setup.playerdata;

import com.minecraftserverzone.weaponmaster.WeaponMasterMod;
import com.minecraftserverzone.weaponmaster.setup.helper.ServerHelper;

import net.minecraft.item.ItemStack;

public class PlayerData {
	//pos1, pos2, pos3, pos4, pos5, pos6, pos7, pos8, pos9, posshield, posbanner, posoffhand;
	public int[] positions = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
	public int[] rotations = new int[WeaponMasterMod.maxDisplaySlotNum * 3];
	public int[] scale = new int[WeaponMasterMod.maxDisplaySlotNum];
	public int[] toggleSlots = new int[WeaponMasterMod.maxDisplaySlotNum + 1];
	public int selectedSlot;
	public ItemStack[] inventory = new ItemStack[WeaponMasterMod.maxDisplaySlotNum];// slot1, slot2, slot3, slot4, slot5, slot6, slot7, slot8, slot9, offhand;
	public String slotAttachments = "1-body,2-body,3-rleg,4-lleg,5-rleg,6-lleg,7-body,8-body,9-rleg,shield-body,banner-head,offhand-lleg,quiver-body";
    public String mover = "none,chest;z;+_none,chest,1;z;+_none,legs;x;-_none,legs;x;+_none,legs,3;x;-_none,legs,4;x;+_none,chest,legs,1;z;+_none,shield;z;+_none,legs,3,5;x;-_none;z;-_none;z;-_none,legs,4,6;x;+_none;z;+";
    public String whitelist = "empty";
    public String blacklist = "empty";
    public String uniqueItemDisplay = "empty";
    public int hideTick = 200;
    public int lastMainhandHit = 1, lastOffhandHit = 1;
    
	public PlayerData() {
		for(int i = 0; i < inventory.length; i++) {
			inventory[i] = ServerHelper.AIR_STACK;
		}
	}
	
//	public void tick(PlayerEntity player) {
////		if(lastMainhandHit > 0 && lastMainhandHit <= hideTick) {
//			if(player.isHandActive() && player.getActiveHand() == Hand.MAIN_HAND) {
//				lastMainhandHit = 1;
////				if(!player.level().isClientSide()) {
////					for(Player sp : player.level().players()) {
////						Networking.sendToClient(new HandActionCPacket(true, player.getUUID()), (ServerPlayer) sp);
////					}
////				}
//				
//				
//			}else if(lastMainhandHit > 0 && lastMainhandHit <= hideTick) {
//				lastMainhandHit++;
//			}
////		}
////		if(lastOffhandHit > 0 && lastOffhandHit <= hideTick) {
//			if(player.isHandActive() && player.getActiveHand() == Hand.OFF_HAND) {
//				lastOffhandHit = 1;
////				if(!player.level().isClientSide()) {
////					for(Player sp : player.level().players()) {
////						Networking.sendToClient(new HandActionCPacket(false, player.getUUID()), (ServerPlayer) sp);
////					}
////				}
//
//			}else if(lastOffhandHit > 0 && lastOffhandHit <= hideTick) {
//				lastOffhandHit++;
//			}
////		}
//	}

	public PlayerData getAllData() {
		return this;
	}
	
	
	
}
